// BenchContainerDlg.cpp : t@C
//

#include "stdafx.h"
#include "BenchContainer.h"
#include "BenchContainerDlg.h"

#include <vector>
#include <list>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// AvP[Ṽo[WɎg CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

// 
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CBenchContainerDlg _CAO




CBenchContainerDlg::CBenchContainerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBenchContainerDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBenchContainerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CBenchContainerDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, &CBenchContainerDlg::OnBnClickedOk)
END_MESSAGE_MAP()


// CBenchContainerDlg bZ[W nh

BOOL CBenchContainerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[VXe j[ɒǉ܂B

	// IDM_ABOUTBOX ́AVXe R}h͈͓̔ɂȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	// TODO: ɒǉ܂B

	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

void CBenchContainerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CBenchContainerDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// [U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CBenchContainerDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


class CPassCounter
{
private:
	bool			m_bOperating;
	LARGE_INTEGER	m_PerformanceFrequency;
	LARGE_INTEGER	m_nResetCount;
	LARGE_INTEGER	m_nStopCount;
public:
	CPassCounter()
		{
			::QueryPerformanceFrequency(&m_PerformanceFrequency);
			m_bOperating = false;
			ResetCount();
		}
	void Start()
		{
			if( m_bOperating ) return;
			LARGE_INTEGER n;
			::QueryPerformanceCounter(&n);
			m_nResetCount.QuadPart += n.QuadPart - m_nStopCount.QuadPart;
			m_bOperating = true;
		}
	void Stop()
		{
			if( !m_bOperating ) return;
			::QueryPerformanceCounter(&m_nStopCount);
			m_bOperating = false;
		}
	void ResetCount()
		{
			SetCount(0);
		}
	void SetCount(_int64 nCount)
		{
			LARGE_INTEGER n;
			::QueryPerformanceCounter(&n);
			m_nResetCount.QuadPart = n.QuadPart - nCount;
			m_nStopCount.QuadPart = m_nResetCount.QuadPart + nCount;
		}
	int GetCount()const
		{
			return static_cast<int>(GetCountReal() * 1000 / m_PerformanceFrequency.QuadPart);
		}
	_int64 GetCountReal()const
		{
			if( m_bOperating ){
				LARGE_INTEGER n;
				::QueryPerformanceCounter(&n);
				return n.QuadPart - m_nResetCount.QuadPart;
			}
			return m_nStopCount.QuadPart - m_nResetCount.QuadPart;
		}

	const LARGE_INTEGER& GetPerformanceFrequency()const
		{
			return m_PerformanceFrequency;
		}
};

class CTimePerformance : public CPassCounter
{
public:
	class CCountUp
	{
		CTimePerformance	&m_pc;
	public:
		CCountUp(CTimePerformance &pc)
			:m_pc(pc)
			{
				pc.Start();
			}
		~CCountUp()
			{
				m_pc.Stop();
			}
	};
private:
	CString	m_sKeyword;
public:
	CTimePerformance(LPCTSTR lpszFormat,...)
		{
			va_list argList;
			va_start(argList,lpszFormat);
			m_sKeyword.FormatV(lpszFormat,argList);
		}
	~CTimePerformance()
		{
			int n = GetCount();
			PutsFile(_T("count.txt"),_T("TotalTime=%5dms %s"),n,m_sKeyword);
		}

	// wt@CɂPs(Ō"\n"t)
	static void PutsFile(
		const CString& sFilename,	// t@C
		LPCTSTR lpszFormat, ...		// ޕ(printf)
	){
		CStdioFile f;
		if( f.Open(sFilename,CFile::modeCreate|CFile::modeNoTruncate|CFile::modeReadWrite|CFile::typeText) ){
			f.SeekToEnd();
			{
				va_list argList;
				va_start(argList,lpszFormat);
				CString s;
				s.FormatV(lpszFormat,argList);
				va_end(argList);
				s += _T("\n");		// "\n"t
				f.WriteString(s.GetBuffer(0));
			}
		}
	}
};


#define PASS(FUNC)																			\
{																							\
	{																						\
		if( funcBenchVector f = (funcBenchVector)::GetProcAddress(dll.m_hDll2005,FUNC) ){	\
			static CTimePerformance _tp(_T("2005 %s"),CString(FUNC));						\
			CTimePerformance::CCountUp _tpc(_tp);											\
			int a = (*f)(dll.m_p2005,3000000-2);											\
			/*ASSERT( a == 2999999 );	*/													\
			n += a;																			\
		}																					\
	}																						\
	{																						\
		if( funcBenchVector f = (funcBenchVector)::GetProcAddress(dll.m_hDll2008,FUNC) ){	\
			static CTimePerformance _tp(_T("2008 %s"),CString(FUNC));						\
			CTimePerformance::CCountUp _tpc(_tp);											\
			int a = (*f)(dll.m_p2008,3000000-2);											\
			ASSERT( a == 2999999 );															\
			n += a;																			\
		}																					\
	}																						\
	{																						\
		if( funcBenchVector f = (funcBenchVector)::GetProcAddress(dll.m_hDll2010,FUNC) ){	\
			static CTimePerformance _tp(_T("2010 %s"),CString(FUNC));						\
			CTimePerformance::CCountUp _tpc(_tp);											\
			int a = (*f)(dll.m_p2010,3000000-2);											\
			ASSERT( a == 2999999 );															\
			n += a;																			\
		}																					\
	}																						\
}


#define PASSLIST(FUNC)																		\
{																							\
	{																						\
		if( funcBenchList f = (funcBenchList)::GetProcAddress(dll.m_hDll2005,FUNC) ){		\
			static CTimePerformance _tp(_T("2005 %s"),CString(FUNC));						\
			CTimePerformance::CCountUp _tpc(_tp);											\
			int a = (*f)(dll.m_l2005,3000000-2);											\
			/*ASSERT( a == 2999999 );		*/												\
			n += a;																			\
		}																					\
	}																						\
	{																						\
		if( funcBenchList f = (funcBenchList)::GetProcAddress(dll.m_hDll2008,FUNC) ){		\
			static CTimePerformance _tp(_T("2008 %s"),CString(FUNC));						\
			CTimePerformance::CCountUp _tpc(_tp);											\
			int a = (*f)(dll.m_l2008,3000000-2);											\
			ASSERT( a == 2999999 );															\
			n += a;																			\
		}																					\
	}																						\
	{																						\
		if( funcBenchList f = (funcBenchList)::GetProcAddress(dll.m_hDll2010,FUNC) ){		\
			static CTimePerformance _tp(_T("2010 %s"),CString(FUNC));						\
			CTimePerformance::CCountUp _tpc(_tp);											\
			int a = (*f)(dll.m_l2010,3000000-2);											\
			ASSERT( a == 2999999 );															\
			n += a;																			\
		}																					\
	}																						\
}


typedef const std::vector<int>* (WINAPI *funcGetVector)(void);
typedef void (WINAPI *funcReleaseVector)(const std::vector<int>*);

typedef const std::list<int>* (WINAPI *funcGetList)(void);
typedef void (WINAPI *funcReleaseList)(const std::list<int>*);

typedef int (WINAPI *funcBenchVector)(const std::vector<int>*,int n);
typedef int (WINAPI *funcBenchList)(const std::list<int>*,int n);

struct CDll
{
	const HMODULE			m_hDll2005,m_hDll2008,m_hDll2010;
	const std::vector<int>	*const m_p2005,*const m_p2008,*const m_p2010;
	const std::list<int>	*const m_l2005,*const m_l2008,*const m_l2010;
	CDll()
		:m_hDll2005(::LoadLibrary(_T("Container2005.dll")))
		,m_hDll2008(::LoadLibrary(_T("Container2008.dll")))
		,m_hDll2010(::LoadLibrary(_T("Container2010.dll")))
		,m_p2005( (*(funcGetVector)::GetProcAddress(m_hDll2005,"GetVector"))() )
		,m_p2008( (*(funcGetVector)::GetProcAddress(m_hDll2008,"GetVector"))() )
		,m_p2010( (*(funcGetVector)::GetProcAddress(m_hDll2010,"GetVector"))() )
		,m_l2005( (*(funcGetList)::GetProcAddress(m_hDll2005,"GetList"))() )
		,m_l2008( (*(funcGetList)::GetProcAddress(m_hDll2008,"GetList"))() )
		,m_l2010( (*(funcGetList)::GetProcAddress(m_hDll2010,"GetList"))() )
		{
		}
	~CDll()
		{
			(*(funcReleaseVector)::GetProcAddress(m_hDll2005,"ReleaseVector"))(m_p2005);
			(*(funcReleaseVector)::GetProcAddress(m_hDll2008,"ReleaseVector"))(m_p2008);
			(*(funcReleaseVector)::GetProcAddress(m_hDll2010,"ReleaseVector"))(m_p2010);
			(*(funcReleaseList)::GetProcAddress(m_hDll2005,"ReleaseList"))(m_l2005);
			(*(funcReleaseList)::GetProcAddress(m_hDll2008,"ReleaseList"))(m_l2008);
			(*(funcReleaseList)::GetProcAddress(m_hDll2010,"ReleaseList"))(m_l2010);
			::FreeLibrary(m_hDll2005);
			::FreeLibrary(m_hDll2008);
			::FreeLibrary(m_hDll2010);
		}
};

void CBenchContainerDlg::OnBnClickedOk()
{

	CDll dll;

	int n = 0;
	for(int i=0; i<100; i++ ){
		PASS("Vector_For");
		PASS("Vector_For2");
		PASS("Vector_StdBind2nd");
		PASS("Vector_BoostBind");
		PASS("Vector_Tr1Bind");
		PASS("Vector_BoostBind_FuncPtr");
		PASS("Vector_Tr1Bind_FuncPtr");
		PASS("Vector_BoostFunction_StdBind2nd");
		PASS("Vector_Tr1Function_StdBind2nd");
		PASS("Vector_BoostFunction_BoostBind_FuncPtr");
		PASS("Vector_Tr1Function_Tr1Bind_FuncPtr");
		PASSLIST("List_StdBind2nd");
		PASSLIST("List_BoostBind");
		PASSLIST("List_Tr1Bind");
	}

	{
		CString s;
		s.Format(_T("%u"),n);
		::AfxMessageBox(s);
	}

}
